﻿using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;
using Prism.Unity;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using System.Windows;
using Toolkit.View;
using Toolkit.ViewMode;

namespace Toolkit
{
    /// <summary>
    /// App.xaml 的交互逻辑
    /// </summary>
    public partial class App : PrismApplication
    {

        protected override Window CreateShell()
        {
            var window = this.Container.Resolve<MainWindow>();

            window.Loaded += (sender, args) =>
            {
                var manager = this.Container.Resolve<IRegionManager>();

               

            };



            // 通过容器创造主界面实例
            return window;


        }

        // 初始化Shell（主窗口）的时候执行这个方法
        protected override void InitializeShell(Window shell)
        {
            // 可以用于实现登录逻辑，以下是伪代码

            //var loginWin = Container.Resolve<MainWindow>();// 创建一个窗口对象
            //if (loginWin == null || loginWin.ShowDialog() != true)// 以模态窗口的方式打开这个窗口对象
            //{
            //    // 不需要App的属性ShutdownMode配合
            //    Application.Current.Shutdown();
            //    // 如果没有强行退出的话，打开主窗口
            //}
        }


        /// <summary>
        /// 用于注册一些内容
        /// </summary>
        /// <param name="containerRegistry"></param>
        /// <exception cref="NotImplementedException"></exception>
        protected override void RegisterTypes(IContainerRegistry containerRegistry)
        {
            containerRegistry.RegisterForNavigation<MainWindow, MainWindowViewMode>();
            containerRegistry.RegisterForNavigation<TcpTrigger, TcpTriggerViewMode>();
            containerRegistry.RegisterForNavigation<TcpWrite, TcpWriteViewMode>();
        }


        protected override void ConfigureModuleCatalog(IModuleCatalog moduleCatalog)
        {
            base.ConfigureModuleCatalog(moduleCatalog);

        }
    }
}
