﻿using Prism.Mvvm;
using Prism.Regions;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Media;
using Toolkit.Log4;
using Toolkit.Tcp;
using Toolkit.View;

namespace Toolkit.ViewMode
{
    public class MainWindowViewMode : BindableBase
    {

        private ObservableCollection<UserControl> items = new ObservableCollection<UserControl>();
        public ObservableCollection<UserControl> Items { get => items; set => items = value; }


        public List<ToolBase.ToolBase> ToolBases = new List<ToolBase.ToolBase>();
        public MainWindowViewMode(IRegionManager regionManager) 
        {
           
            TcpTrigger trigger = new TcpTrigger();
            Items.Add(trigger);
            ToolBases.Add((TcpTriggerViewMode)trigger.DataContext);

            TcpWrite tcpWrite= new TcpWrite();
            Items.Add(tcpWrite);
            ToolBases.Add((TcpWriteViewMode)tcpWrite.DataContext);




            Task.Run(()=> 
            {
                TcpTriggerViewMode tcpTrigger=( TcpTriggerViewMode ) ToolBases[0];
                TcpWriteViewMode  Write=( TcpWriteViewMode ) ToolBases[1];
                //string ss=" ;ver:1.0;tasktype:821;positions:B;dep_name:广东分行（小面额压力）;taskstatus:0;datetime:2025-04-25;phone:13719220892;deal_name:pan892;recv_date:2025-04-25;client_name:tan892;items:[amount<10>currcycode<CNY>itdetail<5|2>];seqid:f804668a132247359f829dce37f7cdf9;taskid:51ee718cfa1a4b30b6dfde13e70982b4;tasknum:C2025033992;totalpack:1;packno:1;";
                //string datsssa = Write.MsgSplit(ss);
                Stopwatch stopwatch = new Stopwatch();
                while ( true) 
                {
                    try
                    {
                        
                        if ( tcpTrigger.SendStrs.Count != 0 && Write.client.socket.Connected)
                        {
                            stopwatch.Restart();
                            
                            Write.Tdata = tcpTrigger.SendStrs[ 0 ];
                            if ( Write.Tdata == "GetMessage" ) 
                            {
                                if ( !Write.GetMessage() ) 
                                {
                                    Write.client.socket.Close();
                                    LogHelper.Info("打印机断开");
                                }
                                
                                ToolBases[ 0 ].SendStrs.RemoveAt(0);
                                continue;
                            }
                            if ( Write.SendMsg(tcpTrigger) )
                            {
                                ToolBases[ 0 ].SendStrs.RemoveAt(0);
                               
                            }
                        }
                        if ( !Write.client.socket.Connected)
                        {
                            
                                Thread.Sleep(10);
                                tcpTrigger.TcpServerStop();
                                Write.client.socket.Close();
                                LogHelper.Info("打印机断开");
                                Write.client.Connect();
                                if ( Write.client.socket.Connected )
                                {
                                    LogHelper.Info("打印机连接成功");
                                    tcpTrigger.server.Start();
                                }
                            
                        }
                       
                    }
                    catch(Exception e) 
                    {
                       
                        LogHelper.Info(e.Message);
                        Thread.Sleep(3000);
                    }
                    Thread.Sleep(50);
                }

            });


            


           




        }
    }
}
